// Right now we only support adding, not renaming

function initDialog() {
	var dialog = document.getElementById('addRenameDatacardDialog');
	var datacardNameText = document.getElementById('datacardName');
	datacardNameText.focus();
}

function onOK() {
	var datacardName = document.getElementById('datacardName').value;
	if (!datacardName) return false;
	datacardName = datacardName.replace(/^\s*/,'').replace(/\s*$/,'');
	if (!datacardName.length) return false;
	window.opener.callback_NewDatacardName(datacardName);
	return true;
}

function onInput() {
	// The OK button should only be enabled if there is some text
	// in the textbox
	var datacardName = document.getElementById('datacardName').value;
	var okButton = document.getElementById('okButton');
	if (datacardName.length) {
		okButton.removeAttribute('disabled');
	} else {
		okButton.setAttribute('disabled','true');
	}
}
