function saveCCData()
{
	saveDatacardField('cc_name', cc_name_val.value);
	saveDatacardField('cc_number', cc_number_val.value);
	saveDatacardField('cc_type', cc_type_val.value);
	saveDatacardField('cc_expire_month', cc_expire_month_val.value);
	saveDatacardField('cc_expire_year', cc_expire_year_val.value);

	if (passwordHasChanged == 1) {
		saveDatacardField('cc_password', cc_password_val.value);
   	} else {
		passwordHasChanged = 0;
	}
	dump("Credit Card Info is now saved!\n");
}

function initCreditCard()
{
	var kPREFContractID = "@mozilla.org/preferences-service;1";
	var kPBIID = Components.interfaces.nsIPrefBranch;
	var gPrefService  = Components.classes[kPREFContractID].getService(kPBIID);		
	var pwdForgot = gPrefService.getBoolPref("formfill.user.reset");
     
	//credit card information
	cc_name_val=new Object();cc_name_val.value="";
	cc_number_val=new Object();cc_number_val.value="";
	cc_type_val=new Object();cc_type_val.value="";
	cc_expire_month_val=new Object();cc_expire_month_val.value=-1;
	cc_expire_year_val=new Object();cc_expire_year_val.value=-1;
	cc_password_val=new Object(); cc_password_val.value="";

	try
	{
		var regDict =
			afService.GetDatacardFieldsByType(
				currentDatacardFile, nsIAutoFillService.FIELDTYPE_REGULAR);
		cc_name_val.value = getDictionaryValue(regDict, 'cc_name');
		cc_number_val.value = getDictionaryValue(regDict, 'cc_number');
		cc_type_val.value = getDictionaryValue(regDict, 'cc_type');
		cc_expire_month_val.value = getDictionaryValue(regDict, 'cc_expire_month');
		cc_expire_year_val.value = getDictionaryValue(regDict, 'cc_expire_year');
		cc_password_val.value = getDictionaryValue(regDict, 'cc_password');
		dump("Credit Card Info is now read!\n");
	}
	catch(e) { }
}

function CCardOK()
{
	// var cardPwd=document.getElementById("CardPwd");
	//	var rcardPwd=document.getElementById("RetypeCardPwd");
	var cardNum = document.getElementById("CardNumber");
	var cardNumValue = cardNum.value;

	if (cardNumValue.length && !validate_ccardNumber(cardNumValue))
	{
		dump("Credit Card Number is invalid \n");
		return false;
	}

	onCCAccept(cardNumValueVerified);
	saveCCData();
	return true;
}

function ccStartUp()
{     
	var cardName = document.getElementById("CardName");
	var cardNumber = document.getElementById("CardNumber");
	var cardType = document.getElementById("cardtypeList");
     
	//set credit card information
	cardName.value = cc_name_val.value;
	cardNumber.value = cc_number_val.value;
	cardType.value = cc_type_val.value;

	//Init drop down items       
	var eMonthIdx = cc_expire_month_val.value; 
	eMonthIdx = parseInt(eMonthIdx, 10);
	dump("eMonthIdx" + eMonthIdx + "\n");

	var eYearIdx = cc_expire_year_val.value; 
	eYearIdx = parseInt(eYearIdx, 10);
	dump("eYEARIdx" + eYearIdx + "\n");
    
	// Process drop down items   
	var expireMonth = document.getElementById("monthList");     
	if (eMonthIdx > -1) 
	{
		eMonthIdx = eMonthIdx - 1;
		expireMonth.selectedIndex = eMonthIdx;
		expireMonth.selected;
	} else {
		expireMonth.selectedIndex = 0;
		expireMonth.selected;
	}

	//Process drop down items	
	var expireYear = document.getElementById("yearList");       
	if (eYearIdx > -1) 
	{
		eYearIdx = eYearIdx - 4;
		expireYear.selectedIndex = eYearIdx;
		expireYear.selected;
	} else {
		expireYear.selectedIndex = 0;
		expireYear.selected;
    }
}


function onCCAccept(cardNumValueVerified)
{
	dump("onCCAccept\n");
	var cardName=document.getElementById("CardName");
	// var cardNumber=document.getElementById("CardNumber"); NOW VERIFIED AND UPDATED
	var cardType = document.getElementById("cardtypeList");

	//ExpireMonth
	var expireMonth=document.getElementById("monthList"); 
   
	var eMonthValue=expireMonth.selectedItem.value; 
  
	//ExpireYear
	var expireYear=document.getElementById("yearList"); 
	var eYearValue=expireYear.selectedItem.value; 

	// var cardPwd=document.getElementById("CardPwd");

	//update data 
	cc_name_val.value=cardName.value;
	cc_number_val.value=cardNumValueVerified; //VERIFIED
	cc_type_val.value=cardType.value;
	// cc_password_val.value=cardPwd.value;

	cc_expire_month_val.value=eMonthValue;
	cc_expire_year_val.value=eYearValue;
}

function validate_ccardNumber(cardNumValue)
{
	var error = "Please Enter your Credit Card number.";

	//The following removes any spaces and any values that are no in the range 0-9
	var stripped = cardNumValue.replace(/\s+/g,''); //strip out spaces
	stripped = stripped.replace(/\D+/g,''); //strip out any value that is not 0-9
        
	//Card must be 16 digits in length or less..no spaces
	if (stripped.length > 16)
	{
		// alert(error); //FIX THIS alert functionality
		return false;
	}

	if (isNaN(parseInt(stripped))) //This is redundant and should never be TRUE
	{
		// alert(error); //FIX THIS alert functionality
		return false;
	}

	cardNumValueVerified = stripped;
	return true;
}
